diff --git a/modules/demux/live555.cpp b/modules/demux/live555.cpp
index 8f819c6..87fd954 100644
--- a/modules/demux/live555.cpp
+++ b/modules/demux/live555.cpp
@@ -1066,31 +1066,13 @@ static int Play( demux_t *p_demux )
     }
     p_sys->i_pcr = 0;
 
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1195257600)
-    for( i = 0; i < p_sys->i_track; i++ )
-    {
-        if( !p_sys->track[i]->b_rtcp_sync )
-            p_sys->track[i]->i_pts = (int64_t) ( p_sys->track[i]->sub->rtpInfo.timestamp * (double)1000000.0 );
-        p_sys->track[i]->i_start_seq = (int)p_sys->track[i]->sub->rtpInfo.seqNum;
-        msg_Info( p_demux, "set startseq: %u", p_sys->track[i]->i_start_seq );
-    }
-#endif
-
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1199404800)
     /* Retrieve the starttime if possible */
     p_sys->i_npt_start = (int64_t)( p_sys->ms->playStartTime() * (double)1000000.0 );
-#else
-    p_sys->i_npt_start = -1;
-#endif
     if( p_sys->i_npt_start < 0 )
         p_sys->i_npt_start = -1;
 
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1199404800)
     /* Retrieve the duration if possible */
     p_sys->i_npt_length = (int64_t)( p_sys->ms->playEndTime() * (double)1000000.0 );
-#else
-    p_sys->i_npt_length = -1;
-#endif
     if( p_sys->i_npt_length < 0 )
         p_sys->i_npt_length = -1;
 
@@ -1107,7 +1089,7 @@ static int Demux( demux_t *p_demux )
     demux_sys_t    *p_sys = p_demux->p_sys;
     TaskToken      task;
 
-    bool      b_send_pcr = true;
+    bool            b_send_pcr = true;
     int64_t         i_pcr = 0;
     int             i;
 
@@ -1119,28 +1101,19 @@ static int Demux( demux_t *p_demux )
         p_sys->b_timeout_call = false;
     }
 
-
     for( i = 0; i < p_sys->i_track; i++ )
     {
         live_track_t *tk = p_sys->track[i];
 
         if( tk->b_asf || tk->b_muxed )
             b_send_pcr = false;
-#if 0
-        if( i_pcr == 0 )
-        {
-            i_pcr = tk->i_pts;
-        }
-        else if( tk->i_pts != 0 && i_pcr > tk->i_pts )
-        {
-            i_pcr = tk->i_pts ;
-        }
-#endif
     }
-    if( p_sys->i_pcr > 0 )
+
+    if( p_sys->i_pcr > 0 & b_send_pcr )
     {
-        if( b_send_pcr )
-            es_out_Control( p_demux->out, ES_OUT_SET_PCR, p_sys->i_pcr );
+        es_out_Control( p_demux->out, ES_OUT_SET_PCR, p_sys->i_pcr );
+        msg_Warn( p_demux, "Sending PCR %lld", p_sys->i_pcr );
+        p_sys->i_pcr = 0;
     }
 
     /* First warn we want to read data */
@@ -1171,16 +1144,14 @@ static int Demux( demux_t *p_demux )
         live_track_t *tk = p_sys->track[i];
 
         if( !tk->b_muxed && !tk->b_rtcp_sync &&
-            tk->sub->rtpSource() && tk->sub->rtpSource()->hasBeenSynchronizedUsingRTCP() )
+            tk->sub->rtpSource() && tk->sub->rtpSource()->hasBeenSynchronizedUsingRTCP() && tk->i_pts)
         {
             msg_Dbg( p_demux, "tk->rtpSource->hasBeenSynchronizedUsingRTCP()" );
 
-            es_out_Control( p_demux->out, ES_OUT_RESET_PCR );
             tk->b_rtcp_sync = true;
-            /* reset PCR */
-            tk->i_pts = 0;
-            p_sys->i_pcr = 0;
-            i_pcr = 0;
+            p_sys->i_pcr = tk->i_pts;
+            es_out_Control( p_demux->out, ES_OUT_SET_PCR, p_sys->i_pcr );
+            msg_Warn( p_demux, "clock gap, setting p_sys->i_pcr to %lld", p_sys->i_pcr);
         }
     }
 
@@ -1263,34 +1234,24 @@ static int Control( demux_t *p_demux, int i_query, va_list args )
                         p_sys->env->getResultMsg() );
                     return VLC_EGENERIC;
                 }
-                es_out_Control( p_demux->out, ES_OUT_RESET_PCR );
-                p_sys->i_pcr = 0;
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1195257600)
-                /* Retrieve RTP-Info values */
+
+                // FIXME: we need to reset PCR here ?
                 for( i = 0; i < p_sys->i_track; i++ )
                 {
-                    //if( !p_sys->track[i]->b_rtcp_sync )
-                    p_sys->track[i]->b_rtcp_sync = false;
-                    p_sys->track[i]->i_pts = (int64_t) ( p_sys->track[i]->sub->rtpInfo.timestamp * (double)1000000.0 );
-                    p_sys->track[i]->i_start_seq = p_sys->track[i]->sub->rtpInfo.seqNum;
-                    msg_Info( p_demux, "set pos startseq: %u", p_sys->track[i]->i_start_seq );
+                    live_track_t *tk = p_sys->track[i];
+                    tk->b_rtcp_sync = false;
+                    tk->i_pts = 0;
+                    p_sys->i_pcr = 0;
+                    es_out_Control( p_demux->out, ES_OUT_RESET_PCR );
                 }
-#endif
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1199404800)
+
                 /* Retrieve the starttime if possible */
                 p_sys->i_npt_start = (int64_t)( p_sys->ms->playStartTime() * (double)1000000.0 );
-#else
-                p_sys->i_npt_start = -1;
-#endif
                 if( p_sys->i_npt_start < 0 )
                     p_sys->i_npt_start = -1;
 
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1199404800)
                 /* Retrieve the duration if possible */
                 p_sys->i_npt_length = (int64_t)( p_sys->ms->playEndTime() * (double)1000000.0 );
-#else
-                p_sys->i_npt_length = -1;
-#endif
                 if( p_sys->i_npt_length < 0 )
                     p_sys->i_npt_length = -1;
 
@@ -1400,32 +1361,23 @@ static int Control( demux_t *p_demux, int i_query, va_list args )
             else if( !b_bool && p_sys->p_timeout != NULL ) 
                 p_sys->p_timeout->b_handle_keep_alive = false;
 
-            es_out_Control( p_demux->out, ES_OUT_RESET_PCR );
-            p_sys->i_pcr = 0;
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1195257600)
-            for( i = 0; i < p_sys->i_track; i++ )
+            // FIXME might need to reset PCR info here when we try to play again.
+            for( i = 0; !b_bool && i < p_sys->i_track; i++ )
             {
-                if( !p_sys->track[i]->b_rtcp_sync )
-                    p_sys->track[i]->i_pts = 0; // (int64_t) ( p_sys->track[i]->sub->rtpInfo.timestamp * (double)1000000.0 );
-                p_sys->track[i]->i_start_seq = p_sys->track[i]->sub->rtpInfo.seqNum;
-                msg_Info( p_demux, "set pause startseq: %u", p_sys->track[i]->i_start_seq );
+                live_track_t *tk = p_sys->track[i];
+                tk->b_rtcp_sync = false;
+                tk->i_pts = 0;
+                p_sys->i_pcr = 0;
+                es_out_Control( p_demux->out, ES_OUT_RESET_PCR );
             }
-#endif
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1199404800)
+
             /* Retrieve the starttime if possible */
             p_sys->i_npt_start = (int64_t)( p_sys->ms->playStartTime() * (double)1000000.0 );
-#else
-            p_sys->i_npt_start = -1;
-#endif
             if( p_sys->i_npt_start < 0 )
                 p_sys->i_npt_start = -1;
 
-#if (LIVEMEDIA_LIBRARY_VERSION_INT >= 1199404800)
             /* Retrieve the duration if possible */
             p_sys->i_npt_length = (int64_t)( p_sys->ms->playEndTime() * (double)1000000.0 );
-#else
-            p_sys->i_npt_length = -1;
-#endif
             if( p_sys->i_npt_length < 0 )
                 p_sys->i_npt_length = -1;
 
@@ -1524,8 +1476,6 @@ static void StreamRead( void *p_private, unsigned int i_size,
     demux_sys_t    *p_sys = p_demux->p_sys;
     block_t        *p_block;
 
-    //msg_Dbg( p_demux, "pts: %d", pts.tv_sec );
-
     int64_t i_pts = (uint64_t)pts.tv_sec * UINT64_C(1000000) +
         (uint64_t)pts.tv_usec;
 
@@ -1591,12 +1541,6 @@ static void StreamRead( void *p_private, unsigned int i_size,
         tk->p_es = es_out_Add( p_demux->out, &tk->fmt );
     }
 
-#if 0
-    fprintf( stderr, "StreamRead size=%d pts=%lld\n",
-             i_size,
-             pts.tv_sec * 1000000LL + pts.tv_usec );
-#endif
-
     /* grow buffer if it looks like buffer is too small, but don't eat
      * up all the memory on strange streams */
     if( i_truncated_bytes > 0 && tk->i_buffer < 2000000 )
@@ -1671,11 +1615,6 @@ static void StreamRead( void *p_private, unsigned int i_size,
         memcpy( p_block->p_buffer, tk->p_buffer, i_size );
     }
 
-    if( p_sys->i_pcr < i_pts )
-    {
-        p_sys->i_pcr = i_pts;
-    }
-
     if( (i_pts != tk->i_pts) && (!tk->b_muxed) )
     {
         p_block->i_pts = i_pts;
